## location-service 2.1+15.04.20150126.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(ubuntu-location-service)

set(UBUNTU_LOCATION_SERVICE_VERSION_MAJOR 2)
set(UBUNTU_LOCATION_SERVICE_VERSION_MINOR 0)
set(UBUNTU_LOCATION_SERVICE_VERSION_PATCH 0)

set(UBUNTU_LOCATION_SERVICE_TRUST_STORE_SERVICE_NAME "UbuntuLocationService")

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -pedantic -Wextra -fPIC")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wall -fno-strict-aliasing -pedantic -Wextra -fPIC")

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

include(cmake/EnableCoverageReport.cmake)
include(cmake/FindGFlags.cmake)
include(cmake/FindGLog.cmake)
include(cmake/PrePush.cmake)
include(CTest)

include(GNUInstallDirs)

find_package(PkgConfig)
find_package(Boost COMPONENTS filesystem system program_options)
find_package(GLog)
find_package(GFlags)
find_package(Threads)
pkg_check_modules(DBUS dbus-1 REQUIRED)
pkg_check_modules(DBUS_CPP dbus-cpp REQUIRED)
pkg_check_modules(JSON_C json-c REQUIRED)
pkg_check_modules(LIBAPPARMOR libapparmor REQUIRED)
pkg_check_modules(NET_CPP net-cpp REQUIRED)
pkg_check_modules(PROCESS_CPP process-cpp REQUIRED)
pkg_check_modules(PROPERTIES_CPP properties-cpp REQUIRED)
pkg_check_modules(TRUST_STORE trust-store REQUIRED)
#####################################################################
# Enable code coverage calculation with gcov/gcovr/lcov
# Usage:
#  * Switch build type to coverage (use ccmake or cmake-gui)
#  * Invoke make, make test, make coverage
#  * Find html report in subdir coveragereport
#  * Find xml report feasible for jenkins in coverage.xml
#####################################################################
IF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -ftest-coverage -fprofile-arcs" )
ENDIF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])

option (DISABLE_ERROR_ON_LOCAL_TYPEDEFS_WARNINGS "Disable errors when local typedefs are unused" ON)
if (DISABLE_ERROR_ON_LOCAL_TYPEDEFS_WARNINGS)
    SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=unused-local-typedefs")
endif (DISABLE_ERROR_ON_LOCAL_TYPEDEFS_WARNINGS)

include_directories(
  ${Boost_INCLUDE_DIRS}
  ${DBUS_INCLUDE_DIRS}
  ${DBUS_CPP_INCLUDE_DIRS}
  ${JSON_C_INCLUDE_DIRS}
  ${LIBAPPARMOR_INCLUDE_DIRS}
  ${NET_CPP_INCLUDE_DIRS}
  ${PROPERTIES_CPP_INCLUDE_DIRS}
  ${PROCESS_CPP_INCLUDE_DIRS}
  ${TRUST_STORE_INCLUDE_DIRS}
  ${GLog_INCLUDE_DIR}
  ${GFlags_INCLUDE_DIR}

  ${CMAKE_SOURCE_DIR}/include/location_service
  ${CMAKE_SOURCE_DIR}/src/location_service
  ${CMAKE_BINARY_DIR}/src/location_service
)

file(GLOB_RECURSE UBUNTU_LOCATION_SERVICE_PUBLIC_HEADERS ${CMAKE_CURRENT_SOURCE_DIR} *.h)

add_subdirectory(data)
add_subdirectory(doc)
add_subdirectory(examples)
add_subdirectory(include)
add_subdirectory(po)
add_subdirectory(src)
add_subdirectory(tests)

# There's no nice way to format this. Thanks CMake.
add_test(LGPL-required
  /bin/sh -c "! grep -rl 'GNU General' ${PROJECT_SOURCE_DIR}/src ${PROJECT_SOURCE_DIR}/include"
)

enable_coverage_report(service)

=== po/CMakeLists.txt ===
include(FindGettext REQUIRED)
find_program(GETTEXT_XGETTEXT_EXECUTABLE xgettext)

set(DOMAIN ubuntu-location-service)
set(POT_FILE ${CMAKE_CURRENT_SOURCE_DIR}/${DOMAIN}.pot)
file(GLOB PO_FILES *.po)

# We look through all source files and find
# usages of i18n::tr.
file(
    GLOB_RECURSE I18N_CPP_SRC_FILES
    ${CMAKE_SOURCE_DIR}/src/*.cpp)

list(SORT I18N_CPP_SRC_FILES)

add_custom_target(
    ubuntu-location-service-pot
    COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE}
        --default-domain=ubuntu-location-service
        --output=${POT_FILE}
        --from-code=UTF-8
        --c++ --add-comments=TRANSLATORS
        --keyword='tr'
        --boost
        --package-name=ubuntu-location-service
        --copyright-holder='Canonical Ltd.'
        ${I18N_CPP_SRC_FILES})

foreach(PO_FILE ${PO_FILES})
    get_filename_component(LANG ${PO_FILE} NAME_WE)
    gettext_process_po_files(${LANG} ALL PO_FILES ${PO_FILE})
    set(INSTALL_DIR ${CMAKE_INSTALL_LOCALEDIR}/${LANG}/LC_MESSAGES)
    install(
        FILES ${CMAKE_CURRENT_BINARY_DIR}/${LANG}.gmo
        DESTINATION ${INSTALL_DIR}
        RENAME ${DOMAIN}.mo)
endforeach(PO_FILE)

=== tests/CMakeLists.txt ===
find_package(Threads)

add_definitions(-DCORE_DBUS_ENABLE_GOOGLE_TEST_FIXTURE -DBOOST_ASIO_DISABLE_MOVE)

option(
    LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER 
    "Rely on dbus test runner to start a private session for testing purposes" 
    ON
)

if (LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER)
    find_program(DBUS_TEST_RUNNER_EXECUTABLE dbus-test-runner)
    message(STATUS "Executing test suite under dbus-test-runner")
endif (LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER)

# Build mongoose as static library to leverage in location reporter testing
add_library(mongoose mongoose.c)
# Explicitly select c99 when compiling mongoose
set_target_properties(
    mongoose
    PROPERTIES COMPILE_FLAGS "-std=c99")

# Build with system gmock and embedded gtest
set (GMOCK_INCLUDE_DIR "/usr/include/gmock/include" CACHE PATH "gmock source include directory")
set (GMOCK_SOURCE_DIR "/usr/src/gmock" CACHE PATH "gmock source directory")
set (GTEST_INCLUDE_DIR "${GMOCK_SOURCE_DIR}/gtest/include" CACHE PATH "gtest source include directory")

add_subdirectory(${GMOCK_SOURCE_DIR} "${CMAKE_CURRENT_BINARY_DIR}/gmock")

macro(LOCATION_SERVICE_ADD_TEST test_name src)
  add_executable(
    ${test_name}
    ${src})

  target_link_libraries(
    ${test_name}

    ubuntu-location-service
    ubuntu-location-service-connectivity
    ubuntu-location-service-provider-daemon
    ubuntu-location-service-daemon

    mongoose

    ${Boost_LIBRARIES}
    ${CMAKE_THREAD_LIBS_INIT}

    ${PROCESS_CPP_LIBRARIES}

    ${ARGN}

    gmock

    gtest
    gtest_main)

  add_test(${test_name} ${CMAKE_CURRENT_BINARY_DIR}/${test_name} --gtest_filter=*-*requires*)

  # Address android's limit on cmdline length and distill ubuntu-location-service into uls
  install(
    TARGETS ${test_name}
    DESTINATION ${CMAKE_INSTALL_BINDIR}/uls-tests
  )
endmacro(LOCATION_SERVICE_ADD_TEST)

include_directories (
  ${CMAKE_SOURCE_DIR}/src/location_service

  ${GMOCK_INCLUDE_DIR}
  ${GTEST_INCLUDE_DIR}
)

LOCATION_SERVICE_ADD_TEST(acceptance_tests acceptance_tests.cpp)
LOCATION_SERVICE_ADD_TEST(boost_ptree_settings_test boost_ptree_settings_test.cpp)
LOCATION_SERVICE_ADD_TEST(connectivity_manager_test connectivity_manager_test.cpp)
LOCATION_SERVICE_ADD_TEST(controller_test controller_test.cpp)
LOCATION_SERVICE_ADD_TEST(criteria_test criteria_test.cpp)
LOCATION_SERVICE_ADD_TEST(daemon_and_cli_tests daemon_and_cli_tests.cpp)
LOCATION_SERVICE_ADD_TEST(default_permission_manager_test default_permission_manager_test.cpp)
LOCATION_SERVICE_ADD_TEST(engine_test engine_test.cpp)
LOCATION_SERVICE_ADD_TEST(harvester_test harvester_test.cpp)
LOCATION_SERVICE_ADD_TEST(demultiplexing_reporter_test demultiplexing_reporter_test.cpp)

if (NET_CPP_FOUND)
  LOCATION_SERVICE_ADD_TEST(ichnaea_reporter_test ichnaea_reporter_test.cpp)
endif()

LOCATION_SERVICE_ADD_TEST(position_test position_test.cpp)
LOCATION_SERVICE_ADD_TEST(provider_selection_policy_test provider_selection_policy_test.cpp)
LOCATION_SERVICE_ADD_TEST(provider_factory_test provider_factory_test.cpp)
LOCATION_SERVICE_ADD_TEST(provider_test provider_test.cpp)
LOCATION_SERVICE_ADD_TEST(wgs84_test wgs84_test.cpp)
LOCATION_SERVICE_ADD_TEST(trust_store_permission_manager_test trust_store_permission_manager_test.cpp)

# Provider-specific test-cases go here.
if (LOCATION_SERVICE_ENABLE_GPS_PROVIDER)
  include_directories(${CMAKE_SOURCE_DIR}/src/location_service)
  LOCATION_SERVICE_ADD_TEST(gps_provider_test gps_provider_test.cpp)
endif(LOCATION_SERVICE_ENABLE_GPS_PROVIDER)

if (LOCATION_SERVICE_ENABLE_GEOCLUE_PROVIDERS)
  add_executable(geoclue_provider_test geoclue_provider_test.cpp)
  target_link_libraries(
    geoclue_provider_test
    
    ubuntu-location-service

    ${CMAKE_THREAD_LIBS_INIT}
    ${Boost_LIBRARIES}
    ${PROCESS_CPP_LIBRARIES}

    gtest
    gtest_main
  )
  if (LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER)
    add_test(geoclue_provider_test ${DBUS_TEST_RUNNER_EXECUTABLE} --task=${CMAKE_CURRENT_BINARY_DIR}/geoclue_provider_test)
  else (LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER)
    add_test(geoclue_provider_test ${CMAKE_CURRENT_BINARY_DIR}/geoclue_provider_test)
  endif (LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER)
endif (LOCATION_SERVICE_ENABLE_GEOCLUE_PROVIDERS)

LOCATION_SERVICE_ADD_TEST(remote_providerd_test remote_providerd_test.cpp)

LOCATION_SERVICE_ADD_TEST(remote_provider_test remote_provider_test.cpp)
LOCATION_SERVICE_ADD_TEST(espoo_provider_test espoo_provider_test.cpp)

=== src/location_service/com/ubuntu/location/CMakeLists.txt ===
if (NET_CPP_FOUND)
  add_definitions(-DCOM_UBUNTU_LOCATION_SERVICE_HAVE_NET_CPP=1)

  set(ICHNAEA_REPORTER_SRCS service/ichnaea_reporter.cpp)
endif()

add_subdirectory(providers)

configure_file(
  service/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/service/config.h @ONLY
)

add_library(
  ubuntu-location-service SHARED

  ${UBUNTU_LOCATION_SERVICE_PUBLIC_HEADERS}

  default_provider_selection_policy.cpp
  non_selecting_provider_selection_policy.cpp

  criteria.cpp
  engine.cpp
  init_and_shutdown.cpp
  position.cpp
  provider.cpp
  provider_factory.cpp
  proxy_provider.cpp
  satellite_based_positioning_state.cpp
  settings.cpp
  set_name_for_thread.cpp
  wifi_and_cell_reporting_state.cpp

  boost_ptree_settings.cpp

  service/default_configuration.cpp
  service/default_permission_manager.cpp
  service/harvester.cpp
  service/demultiplexing_reporter.h
  service/demultiplexing_reporter.cpp
  service/runtime_tests.h
  service/runtime_tests.cpp
  service/trust_store_permission_manager.cpp

  service/implementation.cpp
  service/skeleton.cpp
  service/stub.cpp

  service/session/implementation.cpp
  service/session/interface.cpp
  service/session/skeleton.cpp
  service/session/stub.cpp

  providers/config.cpp

  providers/remote/provider.cpp
  providers/remote/skeleton.cpp
  providers/remote/stub.cpp

  ${ICHNAEA_REPORTER_SRCS}
)

add_library(
  ubuntu-location-service-connectivity SHARED

  set_name_for_thread.cpp

  connectivity/cached_radio_cell.cpp
  connectivity/cached_wireless_network.cpp
  connectivity/manager.cpp
  connectivity/radio_cell.cpp
  connectivity/wireless_network.cpp

  connectivity/ofono_nm_connectivity_manager.cpp
)

set(symbol_map "${CMAKE_SOURCE_DIR}/symbols.map")

set_target_properties(
  ubuntu-location-service

  PROPERTIES
  LINK_FLAGS "${ldflags} -Wl,--version-script,${symbol_map}"
  LINK_DEPENDS ${symbol_map}
  VERSION ${UBUNTU_LOCATION_SERVICE_VERSION_MAJOR}.${UBUNTU_LOCATION_SERVICE_VERSION_MINOR}.${UBUNTU_LOCATION_SERVICE_VERSION_PATCH}
  SOVERSION ${UBUNTU_LOCATION_SERVICE_VERSION_MAJOR}
)

set_target_properties(
  ubuntu-location-service-connectivity

  PROPERTIES
  LINK_FLAGS "${ldflags} -Wl,--version-script,${symbol_map}"
  LINK_DEPENDS ${symbol_map}
  VERSION ${UBUNTU_LOCATION_SERVICE_VERSION_MAJOR}.${UBUNTU_LOCATION_SERVICE_VERSION_MINOR}.${UBUNTU_LOCATION_SERVICE_VERSION_PATCH}
  SOVERSION ${UBUNTU_LOCATION_SERVICE_VERSION_MAJOR}
)

add_definitions(${ENABLED_PROVIDER_TARGETS_DEFINITIONS})

target_link_libraries(
  ubuntu-location-service-connectivity

  ${CMAKE_THREAD_LIBS_INIT}
  ${Boost_LIBRARIES}
  ${DBUS_LIBRARIES}
  ${DBUS_CPP_LDFLAGS}
  ${PROCESS_CPP_LDFLAGS}
  ${GLog_LIBRARY}
  ${GFlags_LIBRARY}
)

target_link_libraries(
  ubuntu-location-service

  ubuntu-location-service-connectivity

  ${ENABLED_PROVIDER_TARGETS}

  ${CMAKE_THREAD_LIBS_INIT}
  ${Boost_LIBRARIES}
  ${DBUS_LIBRARIES}
  ${DBUS_CPP_LDFLAGS}
  ${JSON_C_LDFLAGS}
  ${LIBAPPARMOR_LDFLAGS}
  ${NET_CPP_LDFLAGS}
  ${TRUST_STORE_LDFLAGS}
  ${GLog_LIBRARY}
  ${GFlags_LIBRARY}
)

install(
  TARGETS ubuntu-location-service
  DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(
  TARGETS ubuntu-location-service-connectivity
  DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

add_library(
  ubuntu-location-service-provider-daemon

  service/provider_daemon.cpp
)

add_library(
  ubuntu-location-service-daemon

  service/daemon.cpp
)

add_executable(
  ubuntu-location-service-providerd

  service/provider_daemon_main.cpp
)

add_executable(
  ubuntu-location-serviced

  service/daemon_main.cpp
)

add_executable(
  ubuntu-location-serviced-cli

  service/daemon_cli_main.cpp
)

target_link_libraries(
  ubuntu-location-service-provider-daemon

  ubuntu-location-service
)

target_link_libraries(
  ubuntu-location-service-daemon

  ubuntu-location-service
)

target_link_libraries(
  ubuntu-location-service-providerd

  ubuntu-location-service-provider-daemon

  ${ENABLED_PROVIDER_TARGETS}

  ${Boost_LIBRARIES}
  ${DBUS_LIBRARIES}
  ${DBUS_CPP_LIBRARIES}
  ${GLog_LIBRARY}
  ${GFlags_LIBRARY}
)

target_link_libraries(
  ubuntu-location-serviced

  ubuntu-location-service-daemon

  ${ENABLED_PROVIDER_TARGETS}

  ${Boost_LIBRARIES}
  ${DBUS_LIBRARIES}
  ${DBUS_CPP_LIBRARIES}
  ${GLog_LIBRARY}
  ${GFlags_LIBRARY}
)

target_link_libraries(
  ubuntu-location-serviced-cli

  ubuntu-location-service-daemon

  ${ENABLED_PROVIDER_TARGETS}

  ${Boost_LIBRARIES}
  ${DBUS_LIBRARIES}
  ${DBUS_CPP_LIBRARIES}
  ${GLog_LIBRARY}
  ${GFlags_LIBRARY}
)

install(
  TARGETS ubuntu-location-service-providerd
  DESTINATION ${CMAKE_INSTALL_BINDIR}
)

install(
  TARGETS ubuntu-location-serviced
  DESTINATION ${CMAKE_INSTALL_BINDIR}
)

install(
  TARGETS ubuntu-location-serviced-cli
  DESTINATION ${CMAKE_INSTALL_BINDIR}
)

=== debian/changelog ===
location-service (2.1+15.04.20150126.1-0ubuntu1) vivid; urgency=low

  [ thomas-voss ]
  * Make the remote::Provider::Stub fail loudly on construction if the
    other side is not reachable. Relax the exception in
    location::Daemon::main and do not exit if instantiating a provider
    fails. (LP: #1414591)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Mon, 26 Jan 2015 20:16:32 +0000

location-service (2.1+15.04.20150125~rtm-0ubuntu1) 14.09; urgency=low

  [ CI Train Bot ]
  * Resync trunk

  [ thomas-voss ]
  * Add an interface for querying settings by key. Add an implementation
    leveraging boost::property_tree to provide settings. (LP: #1362765)
  * Allow for enabling/disabling providers. Wire up engine state changes
    to enabling/disabling of providers. (LP: #1392399)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Sun, 25 Jan 2015 12:45:54 +0000

location-service (2.1+15.04.20150113~rtm-0ubuntu1) 14.09; urgency=low

  [ thomas-voss ]
  * Print details about visible space vehicles to the gps provider test
    case. (LP: #1408984)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Tue, 13 Jan 2015 13:01:58 +0000

location-service (2.1+15.04.20150106~rtm-0ubuntu1) 14.09; urgency=low

  [ thomas-voss ]
  * Fix #1394204 by: (LP: #1394204)

  [ Ubuntu daily release ]
  * New rebuild forced

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Tue, 06 Jan 2015 18:50:55 +0000

## location-service 2.1+15.04.20150213

=== src/CMakeLists.txt ===
add_subdirectory(location_service)

=== debian/changelog ===
location-service (2.1+15.04.20150213-0ubuntu1) vivid; urgency=medium

  [ thomas-voss ]
  * Automatically clean up session store for dead clients. (LP:
    #1418033)

 -- CI Train Bot <ci-train-bot@canonical.com>  Fri, 13 Feb 2015 13:54:25 +0000

## location-service 2.1+15.04.20150226

=== debian/changelog ===
location-service (2.1+15.04.20150226-0ubuntu1) vivid; urgency=medium

  [ CI Train Bot ]
  * Launchpad automatic translations update. added: po/af.po po/bg.po
    po/sk.po
  * New rebuild forced.

  [ thomas-voss ]
  * Account for dbus interface breakage in NM from 0.9.8.8 -> 0.9.10.0.

 -- CI Train Bot <ci-train-bot@canonical.com>  Thu, 26 Feb 2015 19:53:44 +0000

## location-service 2.1+15.04.20150427.1

=== debian/changelog ===
location-service (2.1+15.04.20150427.1-0ubuntu1) vivid; urgency=medium

  [ CI Train Bot ]
  * New rebuild forced.

  [ Manuel de la Pena ]
  * Make sure that cached modems are considered as well when calculating
    connection characteristics.

 -- CI Train Bot <ci-train-bot@canonical.com>  Mon, 27 Apr 2015 22:55:52 +0000

location-service (2.1+15.04.20150424-0ubuntu1) vivid; urgency=medium

  [ CI Train Bot ]
  * New rebuild forced.

  [ Manuel de la Pena ]
  * Improve the selection of the bag of providers to ensure that the
    locations used are within a reasonable time margin.
  * Remove the pimpl implementation from the providers and hide their
    public headers because they should only be used within the project.

  [ Thomas Voß ]
  * Increase default timeout for downloading gps xtra data. (LP:
    #1447161)

 -- CI Train Bot <ci-train-bot@canonical.com>  Fri, 24 Apr 2015 14:46:59 +0000

location-service (2.1+15.04.20150417-0ubuntu1) vivid; urgency=medium

  [ CI Train Bot ]
  * New rebuild forced.

  [ Manuel de la Pena ]
  * If an exception is thrown from the io_executor run method it must be
    caught, logger and continued with the main loop.

 -- CI Train Bot <ci-train-bot@canonical.com>  Fri, 17 Apr 2015 09:45:52 +0000

## location-service 2.1+15.10.20150528.3

=== debian/changelog ===
location-service (2.1+15.10.20150528.3-0ubuntu1) wily; urgency=medium

  [ Thomas Voß ]
  * Make sure we always hand a lock owning its mutex to
    on_access_point_added. (LP: #1426307)

 -- CI Train Bot <ci-train-bot@canonical.com>  Thu, 28 May 2015 11:40:58 +0000

## location-service 2.1+15.10.20150529

=== debian/changelog ===
location-service (2.1+15.10.20150529-0ubuntu1) wily; urgency=medium

  [ CI Train Bot ]
  * New rebuild forced.

  [ Manuel de la Pena ]
  * Ensure that the trust store is started when is needed.

 -- CI Train Bot <ci-train-bot@canonical.com>  Fri, 29 May 2015 08:11:15 +0000

=== debian/control ===
Source: location-service
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Thomas Voß <thomas.voss@canonical.com>
Build-Depends: cmake,
               curl,
               libdbus-cpp-dev (>= 4.1.0),
               debhelper (>= 9),
               doxygen,
               geoclue-ubuntu-geoip,
               google-mock (>= 1.6.0+svn437),
               graphviz,
# We rely on C++11 features, and to prevent from ABI breaks
# in libstdc++ causing us issues, we explicitly select a G++
# version.
               g++-4.9,
               libapparmor-dev,
               libboost-filesystem-dev,
               libboost-program-options-dev,
               libboost-system-dev,
               libdbus-1-dev,
               libdbus-cpp-dev,
               libgoogle-glog-dev,
               libgtest-dev,
               libiw-dev,
               libjson-c-dev,
               libnet-cpp-dev,
               libprocess-cpp-dev,
               libtrust-store-dev,
               libubuntu-platform-hardware-api-headers [!arm64 !ppc64el !powerpc],
               libubuntu-platform-hardware-api-dev [!arm64 !ppc64el !powerpc],
               libproperties-cpp-dev,
               trust-store-bin,
Standards-Version: 3.9.4
Homepage: http://launchpad.net/location-service
# If you aren't a member of ~phablet-team but need to upload packaging changes,
# just go ahead.  ~phablet-team will notice and sync up the code again.
Vcs-Bzr: https://code.launchpad.net/~phablet-team/location-service/trunk
Vcs-Browser: http://bazaar.launchpad.net/~phablet-team/location-service/trunk/files

Package: libubuntu-location-service2
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: location service aggregating position/velocity/heading
 updates and exporting them over dbus.
 .
 Contains the shared library needed by client applications.

Package: libubuntu-location-service-dev
Section: libdevel
Architecture: any
Multi-Arch: foreign
Recommends: ubuntu-location-service-doc,
Depends: libubuntu-location-service2 (= ${binary:Version}),
         libdbus-1-dev,
         libdbus-cpp-dev,
         libboost-dev,
         ${misc:Depends},
Suggests: ubuntu-location-service-doc,
Description: location service aggregating position/velocity/heading
 updates and exporting them over dbus.
 .
 Contains header files required to develop clients talking to the ubuntu
 location service.

Package: libubuntu-location-service-dbg
Section: debug
Architecture: any
Multi-Arch: foreign
Depends: libubuntu-location-service2 (= ${binary:Version}),
         ${misc:Depends},
Description: location service aggregating position/velocity/heading
 updates and exporting them over dbus.
 .
 Contains debug symbols.

Package: ubuntu-location-service-tests
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: location service aggregating position/velocity/heading
 updates and exporting them over dbus.
 .
 Contains all test executables

Package: ubuntu-location-service-bin
Architecture: any
Depends: libubuntu-location-service2 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
         trust-store-bin,
Breaks: ubuntu-location-service-examples (<< 0.0.2),
Replaces: ubuntu-location-service-examples (<< 0.0.2),
Description: location service aggregating position/velocity/heading
 updates and exporting them over dbus.
 .
 Contains the service executable and man pages.

Package: ubuntu-location-service-examples
Architecture: any
Multi-Arch: same
Depends: libubuntu-location-service2 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
         ubuntu-location-service-doc,
Description: location service aggregating position/velocity/heading
 updates and exporting them over dbus.
 .
 Contains example service and client.

Package: ubuntu-location-service-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends},
Recommends: ubuntu-location-service-examples,
Description: location service aggregating position/velocity/heading
 updates and exporting them over dbus.
 .
 Contains documentation for service and client.

## location-service 2.1+15.10.20150601.2

=== examples/service/CMakeLists.txt ===
message(STATUS ${Boost_LIBRARIES})
include_directories(
    ${Boost_INCLUDE_DIRS}
    ${DBUS_INCLUDE_DIRS}
    ${DBUS_CPP_INCLUDE_DIRS}

)

link_directories(
  /tmp/wpsapi-4.7.6_05-linux-x86_64/lib
)

add_executable(
    client
    client.cpp
)

add_executable(
    service
    service.cpp
)

target_link_libraries(
    client

    ubuntu-location-service

    ${CMAKE_THREAD_LIBS_INIT}
    ${Boost_LIBRARIES}
    ${DBUS_LIBRARIES}
    ${DBUS_CPP_LDFLAGS}
)

target_link_libraries(
    service

    ubuntu-location-service

    ${CMAKE_THREAD_LIBS_INIT}
    ${Boost_LIBRARIES}
    ${DBUS_LIBRARIES}
    ${DBUS_CPP_LDFLAGS}
)

add_custom_command(
    OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/ubuntu-location-service.1"
    COMMAND ronn --roff --pipe --organization=ubuntu ${CMAKE_CURRENT_SOURCE_DIR}/service.1.ronn > ${CMAKE_CURRENT_BINARY_DIR}/ubuntu-location-service.1
)

add_custom_target(
    ubuntu-location-service-man-page
    DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/ubuntu-location-service.1"
)

install(
    TARGETS service client
    DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/examples/
)

install(
    FILES ${CMAKE_CURRENT_SOURCE_DIR}/ubuntu-location-service.1
    DESTINATION share/doc/${CMAKE_PROJECT_NAME}/man
)

=== examples/standalone/connectivity/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(connectivity)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR})

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")

find_package(GLog)
find_package(PkgConfig)
find_package(Threads)

pkg_check_modules(
  DBUS_CPP 
  dbus-cpp REQUIRED)

pkg_check_modules(
  PROCESS_CPP 
  process-cpp REQUIRED)

pkg_check_modules(
  LOCATION_CONNECTIVITY 
  ubuntu-location-service-connectivity REQUIRED)

include_directories(
  ${DBUS_CPP_INCLUDE_DIRS}
  ${GLog_INCLUDE_DIR}
  ${PROCESS_CPP_INCLUDE_DIRS}
  ${LOCATION_CONNECTIVITY_INCLUDE_DIRS})

add_executable(
  connectivity

  connectivity.cpp)

target_link_libraries(
  connectivity

  ${CMAKE_THREAD_LIBS_INIT}

  ${DBUS_CPP_LDFLAGS}
  ${GLog_LIBRARY}
  ${PROCESS_CPP_LDFLAGS}
  ${LOCATION_CONNECTIVITY_LDFLAGS})

=== debian/changelog ===
location-service (2.1+15.10.20150601.2-0ubuntu1) wily; urgency=medium

  [ CI Train Bot ]
  * New rebuild forced.

  [ Manuel de la Pena ]
  * Ensure that the trust store is started when is needed.

 -- CI Train Bot <ci-train-bot@canonical.com>  Mon, 01 Jun 2015 15:13:06 +0000

## location-service 2.1+15.10.20150624.1

=== debian/changelog ===
location-service (2.1+15.10.20150624.1-0ubuntu1) wily; urgency=medium

  [ Alberto Aguirre ]
  * No change rebuild against platform-api 3

 -- CI Train Bot <ci-train-bot@canonical.com>  Wed, 24 Jun 2015 15:11:09 +0000

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export DPKG_GENSYMBOLS_CHECK_LEVEL=4

include /usr/share/dpkg/default.mk

# Explicitly selecting a G{CC,++}-version here to avoid accidental
# ABI breaks introduced by toolchain updates.
export CC=$(DEB_HOST_GNU_TYPE)-gcc-4.9
export CXX=$(DEB_HOST_GNU_TYPE)-g++-4.9

ifneq (,$(filter $(DEB_HOST_ARCH),ppc64el powerpc arm64))
        LOCATION_SERVICE_ENABLE_GPS_PROVIDER = OFF
else
        LOCATION_SERVICE_ENABLE_GPS_PROVIDER = ON
endif

%:
	dh $@ --parallel --fail-missing

override_dh_install:
	dh_install -Xubuntu-location-service.1 --fail-missing

override_dh_strip:
	dh_strip --dbg-package=libubuntu-location-service-dbg

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_LIBEXECDIR=/usr/lib/$(DEB_HOST_MULTIARCH)/ubuntu-location-service -DCMAKE_C_COMPILER=$(CC) -DCMAKE_CXX_COMPILER=$(CXX) -DLOCATION_SERVICE_ENABLE_GPS_PROVIDER=$(LOCATION_SERVICE_ENABLE_GPS_PROVIDER)

## location-service 2.1+15.10.20150706

=== src/location_service/com/CMakeLists.txt ===
add_subdirectory(ubuntu)

=== src/location_service/com/ubuntu/location/CMakeLists.txt ===
--- 
+++ 
@@ -27,6 +27,7 @@
   proxy_provider.cpp
   satellite_based_positioning_state.cpp
   settings.cpp
+  time_based_update_policy.cpp
   set_name_for_thread.cpp
   wifi_and_cell_reporting_state.cpp

=== debian/changelog ===
location-service (2.1+15.10.20150706-0ubuntu1) wily; urgency=medium

  [ Alberto Aguirre ]
  * No change rebuild against platform-api 3

  [ CI Train Bot ]
  * New rebuild forced.

 -- CI Train Bot <ci-train-bot@canonical.com>  Mon, 06 Jul 2015 18:22:22 +0000

## location-service 2.1+15.10.20150727

=== debian/changelog ===
location-service (2.1+15.10.20150727-0ubuntu1) wily; urgency=medium

  [ CI Train Bot ]
  * New rebuild forced.

  [ Charles Kerr ]
  * drop build-dependency on g++-4.9 (LP: #1452329)

 -- CI Train Bot <ci-train-bot@canonical.com>  Mon, 27 Jul 2015 18:07:37 +0000

=== debian/control ===
--- 
+++ 
@@ -11,10 +11,6 @@
                geoclue-ubuntu-geoip,
                google-mock (>= 1.6.0+svn437),
                graphviz,
-# We rely on C++11 features, and to prevent from ABI breaks
-# in libstdc++ causing us issues, we explicitly select a G++
-# version.
-               g++-4.9,
                libapparmor-dev,
                libboost-filesystem-dev,
                libboost-program-options-dev,

## location-service 3.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 project(ubuntu-location-service)
 
-set(UBUNTU_LOCATION_SERVICE_VERSION_MAJOR 2)
+set(UBUNTU_LOCATION_SERVICE_VERSION_MAJOR 3)
 set(UBUNTU_LOCATION_SERVICE_VERSION_MINOR 0)
 set(UBUNTU_LOCATION_SERVICE_VERSION_PATCH 0)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -80,6 +80,7 @@
 LOCATION_SERVICE_ADD_TEST(engine_test engine_test.cpp)
 LOCATION_SERVICE_ADD_TEST(harvester_test harvester_test.cpp)
 LOCATION_SERVICE_ADD_TEST(demultiplexing_reporter_test demultiplexing_reporter_test.cpp)
+LOCATION_SERVICE_ADD_TEST(time_based_update_policy_test time_based_update_policy_test.cpp)
 
 if (NET_CPP_FOUND)
   LOCATION_SERVICE_ADD_TEST(ichnaea_reporter_test ichnaea_reporter_test.cpp)

=== debian/changelog ===
location-service (3.0.0-0ubuntu3) wily; urgency=medium

  * No change rebuild.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 31 Jul 2015 00:23:18 +0200

location-service (3.0.0-0ubuntu2) wily; urgency=medium

  * libubuntu-location-service3: Replaces libubuntu-location-service2,
    config file /etc/gps.conf in both packages.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 30 Jul 2015 09:57:50 +0200

location-service (3.0.0-0ubuntu1) wily; urgency=medium

  * Bump major revision and fix LP:#1478750 to account for toolchain update.

 -- Thomas Voß <thomas.voss@canonical.com>  Thu, 30 Jul 2015 08:33:13 +0200

=== debian/control ===
--- 
+++ 
@@ -35,13 +35,14 @@
 Vcs-Bzr: https://code.launchpad.net/~phablet-team/location-service/trunk
 Vcs-Browser: http://bazaar.launchpad.net/~phablet-team/location-service/trunk/files
 
-Package: libubuntu-location-service2
+Package: libubuntu-location-service3
 Section: libs
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends},
          ${shlibs:Depends},
+Replaces: libubuntu-location-service2
 Description: location service aggregating position/velocity/heading
  updates and exporting them over dbus.
  .
@@ -52,7 +53,7 @@
 Architecture: any
 Multi-Arch: foreign
 Recommends: ubuntu-location-service-doc,
-Depends: libubuntu-location-service2 (= ${binary:Version}),
+Depends: libubuntu-location-service3 (= ${binary:Version}),
          libdbus-1-dev,
          libdbus-cpp-dev,
          libboost-dev,
@@ -68,7 +69,7 @@
 Section: debug
 Architecture: any
 Multi-Arch: foreign
-Depends: libubuntu-location-service2 (= ${binary:Version}),
+Depends: libubuntu-location-service3 (= ${binary:Version}),
          ${misc:Depends},
 Description: location service aggregating position/velocity/heading
  updates and exporting them over dbus.
@@ -86,7 +87,7 @@
 
 Package: ubuntu-location-service-bin
 Architecture: any
-Depends: libubuntu-location-service2 (= ${binary:Version}),
+Depends: libubuntu-location-service3 (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends},
          trust-store-bin,
@@ -100,7 +101,7 @@
 Package: ubuntu-location-service-examples
 Architecture: any
 Multi-Arch: same
-Depends: libubuntu-location-service2 (= ${binary:Version}),
+Depends: libubuntu-location-service3 (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends},
          ubuntu-location-service-doc,

=== debian/rules ===
--- 
+++ 
@@ -14,11 +14,6 @@
 export DPKG_GENSYMBOLS_CHECK_LEVEL=4
 
 include /usr/share/dpkg/default.mk
-
-# Explicitly selecting a G{CC,++}-version here to avoid accidental
-# ABI breaks introduced by toolchain updates.
-export CC=$(DEB_HOST_GNU_TYPE)-gcc-4.9
-export CXX=$(DEB_HOST_GNU_TYPE)-g++-4.9
 
 ifneq (,$(filter $(DEB_HOST_ARCH),ppc64el powerpc arm64))
         LOCATION_SERVICE_ENABLE_GPS_PROVIDER = OFF

## location-service 3.0.0%2B16.04.20160405-0ubuntu1

=== data/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

configure_file(
  ubuntu-location-service.pc.in ubuntu-location-service.pc @ONLY
)

configure_file(
  ubuntu-location-service-connectivity.pc.in ubuntu-location-service-connectivity.pc @ONLY
)

configure_file(
  ubuntu-location-service.conf.in ubuntu-location-service.conf @ONLY
)

configure_file(
  ubuntu-location-service-trust-stored.conf.in ubuntu-location-service-trust-stored.conf @ONLY
)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/ubuntu-location-service.pc
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/ubuntu-location-service-connectivity.pc
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

install(
  FILES ${CMAKE_CURRENT_SOURCE_DIR}/com.ubuntu.location.Service.conf
  DESTINATION /etc/dbus-1/system.d/
)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/ubuntu-location-service.conf
  DESTINATION /etc/init/
)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/ubuntu-location-service-trust-stored.conf
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/upstart/sessions/
)

=== doc/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

find_package(Doxygen)

if(DOXYGEN_FOUND)
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in 
    ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
  add_custom_target(doc ALL 
    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Generating API documentation with Doxygen" VERBATIM)
  install(
    DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
    DESTINATION share/LocationService/doc)
endif(DOXYGEN_FOUND)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -92,11 +92,13 @@
 LOCATION_SERVICE_ADD_TEST(provider_test provider_test.cpp)
 LOCATION_SERVICE_ADD_TEST(wgs84_test wgs84_test.cpp)
 LOCATION_SERVICE_ADD_TEST(trust_store_permission_manager_test trust_store_permission_manager_test.cpp)
+LOCATION_SERVICE_ADD_TEST(runtime_test runtime_test.cpp)
 
 # Provider-specific test-cases go here.
 if (LOCATION_SERVICE_ENABLE_GPS_PROVIDER)
   include_directories(${CMAKE_SOURCE_DIR}/src/location_service)
   LOCATION_SERVICE_ADD_TEST(gps_provider_test gps_provider_test.cpp)
+  LOCATION_SERVICE_ADD_TEST(sntp_client_test sntp_client_test.cpp)
 endif(LOCATION_SERVICE_ENABLE_GPS_PROVIDER)
 
 if (LOCATION_SERVICE_ENABLE_GEOCLUE_PROVIDERS)
@@ -124,3 +126,6 @@
 
 LOCATION_SERVICE_ADD_TEST(remote_provider_test remote_provider_test.cpp)
 LOCATION_SERVICE_ADD_TEST(espoo_provider_test espoo_provider_test.cpp)
+LOCATION_SERVICE_ADD_TEST(delayed_service_test delayed_service_test.cpp)
+
+LOCATION_SERVICE_ADD_TEST(bug_1447110 bug_1447110.cpp)

=== debian/control ===
--- 
+++ 
@@ -1,3 +1,8 @@
+# This file is autogenerated. DO NOT EDIT!
+#
+# Modifications should be made to control.in instead.
+# This file is regenerated automatically in the clean target.
+#
 Source: location-service
 Section: utils
 Priority: optional
@@ -27,6 +32,7 @@
                libubuntu-platform-hardware-api-headers [!arm64 !ppc64el !powerpc],
                libubuntu-platform-hardware-api-dev [!arm64 !ppc64el !powerpc],
                libproperties-cpp-dev,
+               lsb-release,
                trust-store-bin,
 Standards-Version: 3.9.4
 Homepage: http://launchpad.net/location-service
@@ -35,14 +41,13 @@
 Vcs-Bzr: https://code.launchpad.net/~phablet-team/location-service/trunk
 Vcs-Browser: http://bazaar.launchpad.net/~phablet-team/location-service/trunk/files
 
-Package: libubuntu-location-service3
+Package: libubuntu-location-service2
 Section: libs
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends},
          ${shlibs:Depends},
-Replaces: libubuntu-location-service2
 Description: location service aggregating position/velocity/heading
  updates and exporting them over dbus.
  .
@@ -53,7 +58,7 @@
 Architecture: any
 Multi-Arch: foreign
 Recommends: ubuntu-location-service-doc,
-Depends: libubuntu-location-service3 (= ${binary:Version}),
+Depends: libubuntu-location-service2 (= ${binary:Version}),
          libdbus-1-dev,
          libdbus-cpp-dev,
          libboost-dev,
@@ -69,7 +74,7 @@
 Section: debug
 Architecture: any
 Multi-Arch: foreign
-Depends: libubuntu-location-service3 (= ${binary:Version}),
+Depends: libubuntu-location-service2 (= ${binary:Version}),
          ${misc:Depends},
 Description: location service aggregating position/velocity/heading
  updates and exporting them over dbus.
@@ -87,7 +92,7 @@
 
 Package: ubuntu-location-service-bin
 Architecture: any
-Depends: libubuntu-location-service3 (= ${binary:Version}),
+Depends: libubuntu-location-service2 (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends},
          trust-store-bin,
@@ -101,7 +106,7 @@
 Package: ubuntu-location-service-examples
 Architecture: any
 Multi-Arch: same
-Depends: libubuntu-location-service3 (= ${binary:Version}),
+Depends: libubuntu-location-service2 (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends},
          ubuntu-location-service-doc,

## location-service 3.0.0+16.04.20160404-0ubuntu1

=== include/CMakeLists.txt ===
install(
    DIRECTORY location_service/com
    DESTINATION include/ubuntu-location-service-${UBUNTU_LOCATION_SERVICE_VERSION_MAJOR}
)

=== src/location_service/com/ubuntu/location/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,7 @@
+if (UBUNTU_PLATFORM_HARDWARE_API_FOUND)
+  add_definitions(-DCOM_UBUNTU_LOCATION_SERVICE_HAVE_UBUNTU_PLATFORM_HARDWARE_API)
+endif()
+
 if (NET_CPP_FOUND)
   add_definitions(-DCOM_UBUNTU_LOCATION_SERVICE_HAVE_NET_CPP=1)
 
@@ -9,6 +13,8 @@
 configure_file(
   service/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/service/config.h @ONLY
 )
+
+include_directories(${UBUNTU_PLATFORM_HARDWARE_API_INCLUDE_DIRS})
 
 add_library(
   ubuntu-location-service SHARED
@@ -29,6 +35,7 @@
   settings.cpp
   time_based_update_policy.cpp
   set_name_for_thread.cpp
+  time_since_boot.cpp
   wifi_and_cell_reporting_state.cpp
 
   boost_ptree_settings.cpp
@@ -38,6 +45,7 @@
   service/harvester.cpp
   service/demultiplexing_reporter.h
   service/demultiplexing_reporter.cpp
+  service/runtime.cpp
   service/runtime_tests.h
   service/runtime_tests.cpp
   service/trust_store_permission_manager.cpp
@@ -125,6 +133,7 @@
   ${LIBAPPARMOR_LDFLAGS}
   ${NET_CPP_LDFLAGS}
   ${TRUST_STORE_LDFLAGS}
+  ${UBUNTU_PLATFORM_HARDWARE_API_LDFLAGS}
   ${GLog_LIBRARY}
   ${GFlags_LIBRARY}
 )

=== debian/changelog ===
location-service (3.0.0+16.04.20160404-0ubuntu1) xenial; urgency=medium

  * Enable dual landings according to https://wiki.ubuntu.com/citrain/LandingProcess#Dual-landing_for_stable_and_devel:
    * Both vivid+overlay and xenial packages are built from the same
      source.
    * To account for differences in major revisions (necessary to handle
      the g++ 5 ABI break), we generate install files on the fly.
  * Lower number of concurrent clients to stabilize acceptance test on
    loaded builders.

 -- Thomas Voß <ci-train-bot@canonical.com>  Mon, 04 Apr 2016 19:22:15 +0000

location-service (3.0.0-0ubuntu4) wily-proposed; urgency=medium

  * No change rebuild.

 -- Ken VanDine <ken.vandine@canonical.com>  Mon, 03 Aug 2015 13:33:13 -0400

location-service (3.0.0) wily; urgency=medium

  * Bump major revision and fix LP:#1478750 to account for toolchain update.

 -- Thomas Voß <thomas.voss@canonical.com>  Thu, 30 Jul 2015 08:33:13 +0200

location-service (2.1+15.04.20160331.2-0ubuntu1) vivid; urgency=medium

  * Log to stderr by default, relying on upstart to rotate logs
    appropriately. (LP: #1447110)

 -- Thomas Voß <ci-train-bot@canonical.com>  Thu, 31 Mar 2016 11:03:46 +0000

location-service (2.1+15.04.20160308.1-0ubuntu1) vivid; urgency=medium

  * Add SntpClient for querying reference time information.

 -- Thomas Voß <ci-train-bot@canonical.com>  Tue, 08 Mar 2016 08:54:07 +0000

location-service (2.1+15.04.20160302.1-0ubuntu1) vivid; urgency=medium

  * Remove explicit option to disable satellite-based positioning
    services.

 -- Thomas Voß <ci-train-bot@canonical.com>  Wed, 02 Mar 2016 15:28:02 +0000

location-service (2.1+15.04.20160106-0ubuntu1) vivid; urgency=medium

  [ Alberto Mardegan ]
  * Set debian source format to "3.0 (native)"

  [ Scott Sweeny ]
  * Allow providers to register themselves asynchronously (LP: #1415029)

 -- Thomas Voß <ci-train-bot@canonical.com>  Wed, 06 Jan 2016 16:15:29 +0000

location-service (2.1+15.04.20151211-0ubuntu1) vivid; urgency=medium

  * Account for changes in trust-store w.r.t. assembling the description
    of a trust prompt.

 -- Thomas Voß <ci-train-bot@canonical.com>  Fri, 11 Dec 2015 08:57:44 +0000

location-service (2.1+15.04.20151209-0ubuntu1) vivid; urgency=medium

  * Fix settings not being applied correctly.

 -- Thomas Voß <ci-train-bot@canonical.com>  Wed, 09 Dec 2015 15:22:22 +0000

location-service (2.1+15.04.20151202.1-0ubuntu1) vivid; urgency=medium

  * Ensure that event connections are cleaned up on destruction. (LP:
    #1480877)

 -- Thomas Voß <ci-train-bot@canonical.com>  Wed, 02 Dec 2015 12:12:21 +0000

location-service (2.1+15.04.20151127-0ubuntu1) vivid; urgency=medium

  [ Alberto Mardegan ]
  * Send last known position on session start

  [ CI Train Bot ]
  * New rebuild forced.

  [ Thomas Voß ]
  * Factor out service::Runtime from daemon.cpp into its own .h/.cpp
    pair of files. Add test cases around correct operation of
    service::Runtime. added:
    src/location_service/com/ubuntu/location/service/runtime.cpp
    src/location_service/com/ubuntu/location/service/runtime.h
    tests/runtime_test.cpp

  [ thomas-voss ]
  * Factor out service::Runtime from daemon.cpp into its own .h/.cpp
    pair of files. Add test cases around correct operation of
    service::Runtime. added:
    src/location_service/com/ubuntu/location/service/runtime.cpp
    src/location_service/com/ubuntu/location/service/runtime.h
    tests/runtime_test.cpp

 -- Thomas Voß <ci-train-bot@canonical.com>  Fri, 27 Nov 2015 13:00:33 +0000

location-service (2.1+15.04.20151113-0ubuntu1) vivid; urgency=medium

  * Adjust default timeout for downloading GPS XTRA data.

 -- Thomas Voß <ci-train-bot@canonical.com>  Fri, 13 Nov 2015 10:33:56 +0000

location-service (2.1+15.04.20151109.2-0ubuntu1) vivid; urgency=medium

  [ Alberto Mardegan ]
  * Make sure that injected time is given in milliseconds

  [ Thomas Voß ]
  * Cherry-pick rev. 196 and 199 from lp:location-service. The changes
    got accidentally removed by merging the outstanding documentation
    branch.
  * Handle responses of clients to updates asynchronously. Rely on
    dummy::ConnectivityManager as harvesting is disabled anyway. (LP:
    #1462664, #1387643)

 -- David Barth <david.barth@canonical.com>  Mon, 09 Nov 2015 20:48:48 +0000

location-service (2.1+15.04.20151022-0ubuntu1) vivid; urgency=medium

  [ Thomas Voß ]
  * Add documentation for debugging, hacking and debugging the location
    service. Pull manual testing instructions over from the wiki. Add
    tools for formatting the source.

  [ thomas-voss ]
  * Add documentation for debugging, hacking and debugging the location
    service. Pull manual testing instructions over from the wiki. Add
    tools for formatting the source.

 -- Thomas Voß <ci-train-bot@canonical.com>  Thu, 22 Oct 2015 07:16:50 +0000
